package com.ORM.Greendao;

import java.util.List;
import android.app.Activity;
import android.database.sqlite.SQLiteDatabase;
import android.os.Bundle;
import android.util.Log;
import android.view.Menu;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Toast;
import com.GreenDAO.esquema.*;
import com.GreenDAO.esquema.DaoMaster.DevOpenHelper;
import com.GreenDAO.esquema.LoginDao.Properties;
import com.example.orm_greendao.R;

public class MainActivity extends Activity {

	private SQLiteDatabase db;
	private DaoMaster daoMaster;
    private DaoSession daoSession;
    private LoginDao loginDAO;
    private Button btnComprobar;
    private Button btnRegistrarse;
    private Button btnBorrar;
    private EditText txtUsuario;
    private EditText txtPassword;
    private EditText txtID;
    

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
         
        DevOpenHelper openHelper = new DaoMaster.DevOpenHelper(this, "Autenticacion", null);
        db = openHelper.getWritableDatabase();
        daoMaster = new DaoMaster(db);
        daoSession = daoMaster.newSession();
        loginDAO = daoSession.getLoginDao();
        
        
        btnComprobar = (Button)findViewById(R.id.btnComprobar);
        btnRegistrarse = (Button)findViewById(R.id.btnRegistrarse);
        btnBorrar = (Button)findViewById(R.id.btnBorrar);
        txtUsuario = (EditText)findViewById(R.id.edtUsuario);
        txtPassword = (EditText)findViewById(R.id.edtPassword); 
        txtID = (EditText)findViewById(R.id.edtID);
    }
    
    //Comprobar si existe Usuario
    public void iniciarSesion(View view)
    {
    	String usuario = txtUsuario.getText().toString();
    	List<Login> listUsuario = this.loginDAO.queryBuilder().where(Properties.Usuario.eq(usuario)).list();
    	if(usuario.equals(""))
    	{
    		Toast.makeText(this, "Debe indicar el Usuario a comprobar.", 3000).show();
    	}
    	else
    	{	
			if(listUsuario!= null)
	    		{
					for(Login login : listUsuario)
					{
						Toast.makeText(this, "El usuario indicado existe en la Base de Datos." +
								"\nID:" + login.getId() + "\nUsuario:" + login.getUsuario(),3000).show();		    		
					}					
	    		}
			else
			{
				Toast.makeText(this, "No hay coincidencias.", 3000).show();
			}
    	}
    }
    
    //Insertar nuevo usuario 
    public void registrarCredenciales(View view)
    {   	   	    	
        try{
		    	Login login = new Login();		    	
		    	String usuario = txtUsuario.getText().toString();
		    	String password = txtPassword.getText().toString();
		    	//Comprobamos que los campos no estn vacos
		    	if((usuario.equals("")))
		    	{
		    		Toast.makeText(this, "Debe indicar el Usuario.", 3000).show();
		    	}
		    	else if(password.equals(""))
		    			{
		    				Toast.makeText(this, "Debe indicar el Password de Usuario.", 3000).show();
		    			}
		    	else
		    	{
			    	login.setUsuario(txtUsuario.getText().toString());
			    	login.setPassword(txtPassword.getText().toString());	    	
			    	loginDAO.insert(login);
			    	Toast.makeText(this, "Datos almacenado->\nID: " + login.getId() + "\nUsuario: " + login.getUsuario(), 3000).show();
			    }
		    		Log.d("GreenDAO", "Nuevo usuario almacenado, ID: " + login.getId());
        }catch(Exception ex)
        {
        	System.out.println(ex.getMessage());
        }  	
    }
    
    
    //Borrar usuario por id
    public void borrarRegistro(View vew)
    {
    	 try{
    		 	String id = txtID.getText().toString();
    	    	if(id.equals(""))
		    	{
		    		Toast.makeText(this, "Debe indicar el id del usuario a borrar.", 3000).show();
		    	}
		    	else
		    	{
		    		Long identificador = Long.parseLong(id);		    		 	    	
	    	    	loginDAO.deleteByKey(identificador);
	    	    	Toast.makeText(this, "Datos borrados->\nID: " + identificador, 3000).show();
		    	}    	    	
	        }catch(Exception ex)
	        {
	        	System.out.println(ex.getMessage());
	        }
    }


    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.main, menu);
        return true;
    }
    
}
